// Description: 
//
// Author: Radoslav Atanasov <rsdevelop@gmail.com>, (C) 2005
// Copyright: See COPYING file that comes with this distribution

#include "rs_utils.h"

namespace rs {
	string format (const char * fmt, ...) {
		char buf [1024];
		va_list args;
		va_start (args, fmt);
		vsprintf (buf, fmt, args);
		va_end (args);
		
		return buf;
	}
	
	string replace (const string& inStr, const string& oldValue, const string& newValue) {
		//-TODO
	}
	
	unsigned char cyr_chrupcase (char _ch) {
		unsigned char ch = (unsigned char)_ch;
		if (ch >= 0x61 && ch <= 0x7a)
			return ch - 0x20;
		if (ch >= 0xe0 && ch <= 0xff)
			return ch - 0x20;
		return ch;
	}
	
	int cyr_chricmp (char ch1, char ch2) {
		unsigned char c1 = cyr_chrupcase (ch1);	
		unsigned char c2 = cyr_chrupcase (ch2);
		
		if (c1 < c2) return -1;
		else if (c1 > c2) return 1;
		else return 0;
	}
	
	int cyr_stricmp (const char* s1, const char* s2) {
		size_t len1 = strlen(s1);
		size_t len2 = strlen(s2);
	
		size_t i = 0;
		while (i < len1 && i < len2 && !cyr_chricmp(s1[i], s2[i]))
			i++;
			
		if (i == len1 && i == len2) return 0;
		else if (i == len1) return -1;
		else if (i == len2) return 1;
		else return cyr_chricmp (s1[i], s2[i]);
	}
	
	const char* cyr_stristr (const char* haystack, const char* needle) {
		const char *fPos = haystack;
		for (;;) {
			const char *eqPos = needle, *sPos = fPos;
			while (*eqPos && *sPos && !cyr_chricmp(*eqPos, *sPos))
				++eqPos, ++sPos;
			if (!*eqPos) return fPos;
			if (!*sPos) return NULL;
			fPos++;		
		}						
	}
	
	string g_applicationDirPath;
	
	void extract_application_dirPath (const char* applicationExePath) {
		int pos = int(strlen(applicationExePath) - 1); 
		while (pos >= 0 && applicationExePath [pos] != '/')
			--pos;
		if (pos < 0) g_applicationDirPath = "";
		else 		 g_applicationDirPath = string (applicationExePath, pos);
	}
	
	void set_application_dirPath (const char* dirPath) {
		g_applicationDirPath = dirPath;
	}
	
	string get_application_dirPath () {
		return g_applicationDirPath;
	}
}
