// Description: 
//
// Author: Radoslav Atanasov <rsdevelop@gmail.com>, (C) 2005
// Copyright: See COPYING file that comes with this distribution


#ifndef rsUtils_H
#define rsUtils_H

#include <string>
#include <cstdarg>
using namespace std;

namespace rs {
	string format (const char * fmt, ...); 
	string replace (const string& inStr, const string& oldValue, const string& newValue);
	
	inline string chomp (const char* line) {
		size_t len = strlen (line);
		
		if (line[len-2] == '\r' && line[len-1] == '\n')
			return string (line, len-2);
			
		if (line[len-1] == '\r' || line[len-1] == '\n')
			return string (line, len-1);
		
		return string(line);
	}	
	
	unsigned char cyr_chrupcase (char _ch);
	int cyr_chricmp (char ch1, char ch2);
	int cyr_stricmp (const char* s1, const char* s2);
	const char* cyr_stristr (const char* haystack, const char* needle);
	
	void extract_application_dirPath (const char* applicationExePath);
	void set_application_dirPath (const char* dirPath);
	string get_application_dirPath ();
}

#endif
